%Elastic Collision 1D

x1=0;
Ux1=2;
m1=2;
x2=20;
Ux2=0;
m2=2;

Vx1=Ux1; Vx2=Ux2; %initial value for Velocities
x01=x1; x02=x2; %Initial positions

for i=1:20
    %Calculate current positions
    x1=Vx1*i+x01;
    x2=Vx2*i+x02;

    %Check for collision
    if x1>=x2
        Vx2 = Ux2*(m1-m2)/(m1+m2) + 2*m1*Ux1/(m1+m2);
        Vx1 = Ux1*(m1-m2)/(m1+m2) + 2*m1*Ux2/(m1+m2);
        
        x01=x1; %resets initial position
        x02=x2; %resets initial position
        break
    end
    
    plot(x1,0,'-o',x2,0, '-o',0,0,100,0)
    pause(0.1)
end

for i=1:20
    %Calculate current positions
    x1=Vx1*i+x01;
    x2=Vx2*i+x02;
    
    plot(x1,0,'-o',x2,0, '-o',0,0,100,0)
    pause(0.1)
end
