%Elastic Collision 2D

x01=-90; y01=-90;
Ux1=4; Uy1=4;
m1=2;
x02=90; y02=90;
Ux2=-2; Uy2=-2;
m2=4;

Vx1=Ux1; Vy1=Uy1;
Vx2=Ux2; Vy2=Uy2,
x1=x01; y1=y01;
x2=x02; y2=y02;

for i=1:50
    %Calculate current positions
    x1=Vx1*i+x01;
    y1=Vy1*i+y01;
    
    x2=Vx2*i+x02;
    y2=Vy2*i+y02;

    %Check for collision
    if x1>=x2 & y1>=y2
        %Calculate new velocities
        
        Vx1 = Ux1*(m1-m2)/(m1+m2) + 2*m1*Ux2/(m1+m2);
        Vy1 = Uy1*(m1-m2)/(m1+m2) + 2*m1*Uy2/(m1+m2);
        
        Vx2 = Ux2*(m1-m2)/(m1+m2) + 2*m1*Ux1/(m1+m2);
        Vy2 = Uy2*(m1-m2)/(m1+m2) + 2*m1*Uy1/(m1+m2);
        
        
        %reset initial position
        x01=x1; 
        x02=x2; 
        y01=y1; 
        y02=y2;
        
        break
    end
    
    plot(x1,y1,'-o',x2,y2, '-o',0,0,100,0,0,100,100,100,-100,-100)
    pause(0.1)
    
end

for i=1:16
    %Calculate current positions
    x1=Vx1*i+x01;
    x2=Vx2*i+x02;
    
    x2=Vx2*i+x02;
    y2=Vy2*i+y02;
    
    plot(x1,y1,'-o',x2,y2, '-o',0,0,100,0,0,100,100,100,-100,-100)
    pause(0.1)
end