%Sierpinski Carpet

M = 3^5;
A = ones(M,M);

N=M;

while rem(N,1)==0
    for s = 1:M/N
        for i = (s-1)*N + (1+N/3):(s-1)*N + 2*N/3
            for t = 1:M/N
                for j = (t-1)*N + (1+N/3):(t-1)*N + 2*N/3
                    A(i,j)=0;
                end
            end
        end
    end
    
    imagesc(A);
    set(gca,'YDir','normal');
    colormap(1-gray);
    axis equal;
    axis tight;
 
    
    pause(0.3)
    
    N = N/3;
end
    